function J = Mico_4DOF_Jacobian(q, T_EE_Tool)
%#codegen
D1 = 0.2755; % Base to elbow
D2 = 0.2900; % Arm lengh
D3 = 0.1233; % Front arm lengh
D4 = 0.1600; % Wrist to center of the hand

% ************************************************
% % A = DH(theta_z, d_z, a_x, alpha_x)
A1 = DH (q(1), D1, 0, 0);
A2 = DH (q(2), 0, 0, -pi/2);
A3 = DH (q(3), 0, D2, 0);
A4= DH (q(4),D3,0,-pi/2);
A_EE= DH (0, D4, 0, 0);

%T4=A1*A2*A3*A4;


z0 = A1(1:3,3);
p0 = A1(1:3,4);
T2 = A1*A2;
z1 = T2(1:3,3);
p1 = T2(1:3,4);
T3 = A1*A2*A3;
z2 = T3(1:3,3);
p2 = T3(1:3,4);
T4 = A1*A2*A3*A4;
z3 = T4(1:3,3);
p3 = T4(1:3,4);
T_EE=T4*A_EE;
T_tool = T_EE * T_EE_Tool(1:4,4);
p = T_tool(1:3);


J = [cross(z0,(p-p0)) cross(z1,(p-p1)) cross(z2,(p-p2)) cross(z3,(p-p3))
    z0 z1 z2 z3];