% Compute the forward kinematics:
function T_tool = Mico_4DOF_FPK(q, T_EE_Tool)
%#codegen
D1 = 0.2755; % Base to elbow
D2 = 0.2900; % Arm lengh
D3 = 0.1233; % Front arm lengh
D4 = 0.1600; % Wrist to center of the hand

% ************************************************
% % A = DH(theta_z, d_z, a_x, alpha_x)
A1 = DH (q(1), D1, 0, 0);
A2 = DH (q(2), 0, 0, -pi/2);
A3 = DH (q(3), 0, D2, 0);
A4= DH (q(4),D3+D4,0,-pi/2);

T4=A1*A2*A3*A4;
T_tool= T4*T_EE_Tool;



